//+------------------------------------------------------------------+
//|                               BatFink Daily Range Indicator.mq4  |
//|                                Copyright  2005, Markj           |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005"
#property link      "mailto:batfink7234@yahoo.com.au"

#property indicator_chart_window
#property indicator_buffers 8
#property  indicator_color1  White
#property  indicator_color2  BurlyWood
#property  indicator_color3  BurlyWood
#property  indicator_color4  Yellow
#property  indicator_color5  Yellow
#property  indicator_color6  Gold
#property  indicator_color7  Gold
#property  indicator_color8  Red

//---- input parameters

extern int DailyOpen=0;

//---- variables
int indexbegin = 0;
double dailyopen = 0;

//---- buffers
double DailyOpenBuffer[];
double T1BBuffer[]; 
double T1SBuffer[]; 
double T2BBuffer[]; 
double T2SBuffer[]; 
double T3BBuffer[]; 
double T3SBuffer[]; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
	SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
	SetIndexBuffer(0, DailyOpenBuffer);
	SetIndexLabel(0, "Daily Open");
	SetIndexEmptyValue(0, 0.0);
	
	SetIndexStyle(1, DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(1, T1BBuffer);

   SetIndexStyle(2, DRAW_LINE,STYLE_DOT, 1);
   SetIndexBuffer(2, T1SBuffer);

   SetIndexStyle(3, DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(3, T2BBuffer);

   SetIndexStyle(4, DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(4, T2SBuffer);

   SetIndexStyle(5, DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(5, T3BBuffer);
   
   SetIndexStyle(6, DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(6, T3SBuffer);


//----
	indexbegin = Bars - 20;
	if (indexbegin < 0)
		indexbegin = 0;


	return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
	
//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i;
	int counted_bars = IndicatorCounted();

	
	//---- check for possible errors
	if (counted_bars < 0) counted_bars = 0;
	//---- last counted bar will be recounted
	if (counted_bars > 0) counted_bars--;
	if (counted_bars > indexbegin) counted_bars = indexbegin;


		for (i = indexbegin-counted_bars; i >= 0; i--)
		{
			if ((TimeMinute(Time[i]) == 0) && (TimeHour(Time[i]) - DailyOpen == 0))
				dailyopen = Open[i];
			DailyOpenBuffer[i] = dailyopen;
			
         T1BBuffer[i] = dailyopen+(55*Point);
         T1SBuffer[i] = dailyopen+(-55*Point);
         T2BBuffer[i] = dailyopen-(70*Point);
         T2SBuffer[i] = dailyopen-(-70*Point);
         T3BBuffer[i] = dailyopen-(85*Point);
         T3SBuffer[i] = dailyopen-(-85*Point);
			}

	
	return(0);

}
//+------------------------------------------------------------------+