//+------------------------------------------------------------------+
//|                               BatFink Daily Range Indicator.mq4  |
//|                                Copyright  2005, Markj           |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005"
#property link      "mailto:batfink7234@yahoo.com.au"

#property indicator_chart_window
#property indicator_buffers 7
#property  indicator_color1  White
#property  indicator_color2  OrangeRed
#property  indicator_color3  OrangeRed
#property  indicator_color4  Red
#property  indicator_color5  Red
#property  indicator_color6  Red
#property  indicator_color7  Red

//---- input parameters

extern int DailyOpen=0;

//---- variables
int indexbegin = 0;
double dailyopen = 0;

//---- buffers
double DailyOpenBuffer[];
double T4BBuffer[]; 
double T4SBuffer[]; 
double T5BBuffer[]; 
double T5SBuffer[];
double T5BStopBuffer[]; 
double T5SStopBuffer[];   

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
	SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
	SetIndexBuffer(0, DailyOpenBuffer);
	SetIndexLabel(0, "Daily Open");
	SetIndexEmptyValue(0, 0.0);
	
	SetIndexStyle(1, DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(1, T4BBuffer);

   SetIndexStyle(2, DRAW_LINE,STYLE_DOT, 1);
   SetIndexBuffer(2, T4SBuffer);

   SetIndexStyle(3, DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(3, T5BBuffer);

   SetIndexStyle(4, DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(4, T5SBuffer);
   
   SetIndexStyle(5, DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(5, T5BStopBuffer);

   SetIndexStyle(6, DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(6, T5SStopBuffer);

//----
	indexbegin = Bars - 20;
	if (indexbegin < 0)
		indexbegin = 0;


	return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
	
//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i;
	int counted_bars = IndicatorCounted();

	
	//---- check for possible errors
	if (counted_bars < 0) counted_bars = 0;
	//---- last counted bar will be recounted
	if (counted_bars > 0) counted_bars--;
	if (counted_bars > indexbegin) counted_bars = indexbegin;


		for (i = indexbegin-counted_bars; i >= 0; i--)
		{
			if ((TimeMinute(Time[i]) == 0) && (TimeHour(Time[i]) - DailyOpen == 0))
				dailyopen = Open[i];
			DailyOpenBuffer[i] = dailyopen;
			
         T4BBuffer[i] = dailyopen+(100*Point);
         T4SBuffer[i] = dailyopen+(-100*Point);
         T5BBuffer[i] = dailyopen-(160*Point);
         T5SBuffer[i] = dailyopen-(-160*Point);
         T5BStopBuffer[i] = dailyopen-(190*Point);
         T5SStopBuffer[i] = dailyopen-(-190*Point);
			}
	
	return(0);

}
//+------------------------------------------------------------------+